记录我的一些生活写照、无聊的牢骚、内心世界的活动 注册 | 登陆

Debian(Ubuntu)网络安装/重装一键脚本

Debian(Ubuntu)网络安装/重装一键脚本背景:
适用于由GRUB引导的CentOS,Ubuntu,Debian系统.
使用官方发行版去掉模板预装的软件.
同时也可以解决内核版本与软件不兼容的问题。
只要有root权限,还您一个纯净的系统。
注意:
全自动安装默认root密码: Vicer,安装完成后请立即更改密码.
请使用 passwd root 命令更改密码.
特别注意: OpenVZ 架不适用.
需要:
1. Debian/Ubuntu/CentOS 系统(由 GRUB 引导);
2. wget 用来下载文件,获取公网IP;
3. ip 获取网关,掩码等;
4. sed awk grep 处理文本流;
5. VNC 安装系统(此项为可选)。
#Debian/Ubuntu:
apt-get install -y gawk sed grep
#RedHat/CentOS:
yum install -y gawk sed grep
如果出现了错误,请运行:
 #Debian/Ubuntu:
apt-get update
#RedHat/CentOS:
yum update
一键下载及使用:
wget --no-check-certificate -qO DebianNET.sh 'https://moeclub.org/attachment/LinuxShell/DebianNET.sh' && chmod -x DebianNET.sh
Usage:
bash DebianNET.sh       -d/--debian [7/wheezy|8/jessie|9/stretch]
                                   -v/--ver [32/i386|64/amd64]
安装示例:
全自动安装:
bash DebianNET.sh -d wheezy -v i386 -a
VNC手动安装:
bash DebianNET.sh -d wheezy -v i386 -m
使用:
【默认】安装Debian 7 x32:
bash DebianNET.sh -d wheezy -v i386
-或者
bash DebianNET.sh -d 7 -v 32
安装Debian 7 x64:
bash DebianNET.sh -d wheezy -v amd64
-或者
bash DebianNET.sh -d 7 -v 64
安装Debian 8 x32:
bash DebianNET.sh -d jessie -v i386
-或者
bash DebianNET.sh -d 8 -v 32
安装Debian 8 x64:
bash DebianNET.sh -d jessie -v amd64
-或者
bash DebianNET.sh -d 8 -v 64
安装Debian 9 x32:
bash DebianNET.sh -d stretch -v i386
-或者
bash DebianNET.sh -d 9 -v 32
安装Debian 9 x64:
bash DebianNET.sh -d stretch -v amd64
-或者
bash DebianNET.sh -d 9 -v 64
安装Ubuntu 14.04 x32:
bash DebianNET.sh -d trusty -v 32
安装Ubuntu 14.04 x64:
bash DebianNET.sh -d trusty -v 64
安装Debian 16.04 x32:
bash DebianNET.sh -d xenial -v 32
安装Debian 16.04 x64:
bash DebianNET.sh -d xenial -v 64
安装Debian 17.04 x32:
bash DebianNET.sh -d zesty -v 32
安装Debian 17.04 x64:
bash DebianNET.sh -d zesty -v 64
完整代码:
XML/HTML代码
  1. #!/bin/bash  
  2.    
  3. while [[ $# -ge 1 ]]; do  
  4.   case $1 in  
  5.     -v|--ver)  
  6.       shift  
  7.       VERtmp="$1"  
  8.       shift  
  9.       ;;  
  10.     -d|--debian|--ubuntu)  
  11.       shift  
  12.       vDEBtmp="$1"  
  13.       shift  
  14.       ;;  
  15.     -p|--password)  
  16.       shift  
  17.       WDtmp="$1"  
  18.       shift  
  19.       ;;  
  20.     -a|--auto)  
  21.       shift  
  22.       INStmp='auto'  
  23.       ;;  
  24.     -m|--manual)  
  25.       shift  
  26.       INStmp='manual'  
  27.       ;;  
  28.     -apt|--mirror)  
  29.       shift  
  30.       isMirror='1'  
  31.       tmpMirror="$1"  
  32.       shift  
  33.       ;;  
  34.     *)  
  35.       echo -ne " Usage:\n\tbash $0\t-d/--debian [7/\033[33m\033[04mwheezy\033[0m|8/jessie|9/stretch]\n\t\t\t\t-v/--ver [32/\033[33m\033[04mi386\033[0m|64/amd64]\n\t\t\t\t-apt/--mirror\n\t\t\t\t-a/--auto\n\t\t\t\t-m/--manual\n"  
  36.       exit 1;  
  37.       ;;  
  38.     esac  
  39.   done  
  40.    
  41. [ $EUID -ne 0 ] && echo "Error:This script must be run as root!" && exit 1  
  42. [ -f /boot/grub/grub.cfg ] && GRUBOLD='0' && GRUBDIR='/boot/grub' && GRUBFILE='grub.cfg'  
  43. [ -z $GRUBDIR ] && [ -f /boot/grub2/grub.cfg ] && GRUBOLD='0' && GRUBDIR='/boot/grub2' && GRUBFILE='grub.cfg'  
  44. [ -z $GRUBDIR ] && [ -f /boot/grub/grub.conf ] && GRUBOLD='1' && GRUBDIR='/boot/grub' && GRUBFILE='grub.conf'  
  45. [ -z $GRUBDIR -o -z $GRUBFILE ] && echo "Error! Not Found grub path." && exit 1  
  46.    
  47. [ -n $vDEBtmp ] && {  
  48. [ "$vDEBtmp" == '7' -o "$vDEBtmp" == 'wheezy' ] && linuxdists='debian' && vDEB='wheezy';  
  49. [ "$vDEBtmp" == '8' -o "$vDEBtmp" == 'jessie' ] && linuxdists='debian' && vDEB='jessie';  
  50. [ "$vDEBtmp" == '9' -o "$vDEBtmp" == 'stretch' ] && linuxdists='debian' && vDEB='stretch';  
  51. [ "$vDEBtmp" == 'precise' ] && linuxdists='ubuntu' && vDEB='precise';  
  52. [ "$vDEBtmp" == 'trusty' ] && linuxdists='ubuntu' && vDEB='trusty';  
  53. [ "$vDEBtmp" == 'wily' ] && linuxdists='ubuntu' && vDEB='wily';  
  54. [ "$vDEBtmp" == 'xenial' ] && linuxdists='ubuntu' && vDEB='xenial';  
  55. [ "$vDEBtmp" == 'yakkety' ] && linuxdists='ubuntu' && vDEB='yakkety';  
  56. [ "$vDEBtmp" == 'zesty' ] && linuxdists='ubuntu' && vDEB='zesty';  
  57. }  
  58. [ -n $vDEBtmp ] && {  
  59. [ "$VERtmp" == '32' -o "$VERtmp" == 'i386' ] && VER='i386';  
  60. [ "$VERtmp" == '64' -o "$VERtmp" == 'amd64' ] && VER='amd64';  
  61. }  
  62.    
  63. [ -z $linuxdists ] && linuxdists='debian'  
  64. [ -n $isMirror ] && [ "$isMirror" == '1' ] && [ -n $tmpMirror ] && {  
  65. tmpDebianMirror="$(echo -n "$tmpMirror" |grep -Eo '.*\.(\w+)')"  
  66. echo -n "$tmpDebianMirror" |grep -q '://'  
  67. [ $? -eq '0' ] && {  
  68. DebianMirror="$(echo -n "$tmpDebianMirror" |awk -F'://' '{print $2}')"  
  69. } || {  
  70. DebianMirror="$(echo -n "$tmpDebianMirror")"  
  71. }  
  72. } || {  
  73. [[ $linuxdists == 'debian' ]] && DebianMirror='httpredir.debian.org'  
  74. [[ $linuxdists == 'ubuntu' ]] && DebianMirror='archive.ubuntu.com'  
  75. }  
  76. [ -z $DebianMirrorDirectory ] && [ -n $DebianMirror ] && [ -n $tmpMirror ] && {  
  77. DebianMirrorDirectory="$(echo -n "$tmpMirror" |awk -F''${DebianMirror}'' '{print $2}' |sed 's/\/$//g')"  
  78. }  
  79. [ "$DebianMirrorDirectory" == '/' ] && [ -n $DebianMirror ] && {  
  80. [[ $linuxdists == 'debian' ]] && DebianMirrorDirectory='/debian'  
  81. [[ $linuxdists == 'ubuntu' ]] && DebianMirrorDirectory='/ubuntu'  
  82. }  
  83. [ -z $DebianMirrorDirectory ] && [ -n $DebianMirror ] && {  
  84. [[ $linuxdists == 'debian' ]] && DebianMirrorDirectory='/debian'  
  85. [[ $linuxdists == 'ubuntu' ]] && DebianMirrorDirectory='/ubuntu'  
  86. }  
  87.    
  88. [ -n $INStmp ] && {  
  89. [ "$INStmp" == 'auto' ] && inVNC='n'  
  90. [ "$INStmp" == 'manual' ] && inVNC='y'  
  91. }  
  92. [ -n $WDtmp ] && myPASSWORD="$WDtmp"  
  93.    
  94. [ -z $vDEB ] && vDEB='wheezy';  
  95. [ -z $VER ] && VER='i386';  
  96. [ -z $myPASSWORD ] && myPASSWORD='Vicer'  
  97.    
  98. clear && echo -e "\n\033[36m# Install\033[0m\n"  
  99.    
  100. [ -z $inVNC ] && ASKVNC(){  
  101. inVNC='y';  
  102. echo -ne "\033[34mCan you login VNC?\033[0m\e[33m[\e[32my\e[33m/n]\e[0m "  
  103. read inVNCtmp  
  104. [[ -n "$inVNCtmp" ]] && inVNC=$inVNCtmp  
  105. [ "$inVNC" == 'y' -o "$inVNC" == 'Y' ] && inVNC='y'  
  106. [ "$inVNC" == 'n' -o "$inVNC" == 'N' ] && inVNC='n'  
  107. }  
  108.    
  109. [ "$inVNC" == 'y' -o "$inVNC" == 'n' ] || ASKVNC;  
  110.    
  111. [[ $linuxdists == 'debian' ]] && LinuxName='Debian'  
  112. [[ $linuxdists == 'ubuntu' ]] && LinuxName='Ubuntu'  
  113. [ "$inVNC" == 'y' ] && echo -e "\033[34mManual Mode\033[0m insatll \033[33m$LinuxName\033[0m [\033[33m$vDEB\033[0m] [\033[33m$VER\033[0m] in VNC. "  
  114. [ "$inVNC" == 'n' ] && echo -e "\033[34mAuto Mode\033[0m insatll \033[33m$LinuxName\033[0m [\033[33m$vDEB\033[0m] [\033[33m$VER\033[0m]. "  
  115.    
  116. echo -e "\n[\033[33m$vDEB\033[0m] [\033[33m$VER\033[0m] Downloading..."  
  117. [ -z $DebianMirror ] && echo -ne "\033[31mError! \033[0mGet debian mirror fail! \n" && exit 1  
  118. [ -z $DebianMirrorDirectory ] && echo -ne "\033[31mError! \033[0mGet debian mirror directory fail! \n" && exit 1  
  119. wget --no-check-certificate -qO '/boot/initrd.gz' "http://$DebianMirror$DebianMirrorDirectory/dists/$vDEB/main/installer-$VER/current/images/netboot/$linuxdists-installer/$VER/initrd.gz"  
  120. [ $? -ne '0' ] && echo -ne "\033[31mError! \033[0mDownload 'initrd.gz' failed! \n" && exit 1  
  121. wget --no-check-certificate -qO '/boot/linux' "http://$DebianMirror$DebianMirrorDirectory/dists/$vDEB/main/installer-$VER/current/images/netboot/$linuxdists-installer/$VER/linux"  
  122. [ $? -ne '0' ] && echo -ne "\033[31mError! \033[0mDownload 'linux' failed! \n" && exit 1  
  123.    
  124. DEFAULTNET="$(ip route show |grep -o 'default via [0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.*' |head -n1 |sed 's/proto.*\|onlink.*//g' |awk '{print $NF}')"  
  125. [ -n "$DEFAULTNET" ] && IPSUB="$(ip addr |grep ''${DEFAULTNET}'' |grep 'global' |grep 'brd' |head -n1 |grep -o '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}/[0-9]\{1,2\}')"  
  126. IPv4="$(echo -n "$IPSUB" |cut -d'/' -f1)"  
  127. NETSUB="$(echo -n "$IPSUB" |grep -o '/[0-9]\{1,2\}')"  
  128. GATE="$(ip route show |grep -o 'default via [0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}' |head -n1 |grep -o '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}')"  
  129. [ -n "$NETSUB" ] && MASK="$(echo -n '128.0.0.0/1,192.0.0.0/2,224.0.0.0/3,240.0.0.0/4,248.0.0.0/5,252.0.0.0/6,254.0.0.0/7,255.0.0.0/8,255.128.0.0/9,255.192.0.0/10,255.224.0.0/11,255.240.0.0/12,255.248.0.0/13,255.252.0.0/14,255.254.0.0/15,255.255.0.0/16,255.255.128.0/17,255.255.192.0/18,255.255.224.0/19,255.255.240.0/20,255.255.248.0/21,255.255.252.0/22,255.255.254.0/23,255.255.255.0/24,255.255.255.128/25,255.255.255.192/26,255.255.255.224/27,255.255.255.240/28,255.255.255.248/29,255.255.255.252/30,255.255.255.254/31,255.255.255.255/32' |grep -o '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}'${NETSUB}'' |cut -d'/' -f1)"  
  130.    
  131. [ -n "$GATE" ] && [ -n "$MASK" ] && [ -n "$IPv4" ] || {  
  132. echo "Not found `ip command`, It will use `route command`."  
  133. ipNum() {  
  134.   local IFS='.'  
  135.   read ip1 ip2 ip3 ip4 <<<"$1"  
  136.   echo $((ip1*(1<<24)+ip2*(1<<16)+ip3*(1<<8)+ip4))  
  137. }  
  138.    
  139. SelectMax(){  
  140. ii=0  
  141. for IPITEM in `route -n |awk -v OUT=$1 '{print $OUT}' |grep '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}'`  
  142.   do  
  143.     NumTMP="$(ipNum $IPITEM)"  
  144.     eval "arrayNum[$ii]='$NumTMP,$IPITEM'"  
  145.     ii=$[$ii+1]  
  146.   done  
  147. echo ${arrayNum[@]} |sed 's/\s/\n/g' |sort -n -k 1 -t ',' |tail -n1 |cut -d',' -f2  
  148. }  
  149.    
  150. [[ -z $IPv4 ]] && IPv4="$(ifconfig |grep 'Bcast' |head -n1 |grep -o '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}' |head -n1)"  
  151. [[ -z $GATE ]] && GATE="$(SelectMax 2)"  
  152. [[ -z $MASK ]] && MASK="$(SelectMax 3)"  
  153.    
  154. [ -n "$GATE" ] && [ -n "$MASK" ] && [ -n "$IPv4" ] || {  
  155. echo "Error! Not configure network. "  
  156. exit 1  
  157. }  
  158. }  
  159.    
  160. [ -f /etc/network/interfaces ] && {  
  161. [[ -z "$(sed -n '/iface.*inet static/p' /etc/network/interfaces)" ]] && AutoNet='1' || AutoNet='0'  
  162. [ -d /etc/network/interfaces.d ] && {  
  163. ICFGN="$(find /etc/network/interfaces.d -name '*.cfg' |wc -l)" || ICFGN='0'  
  164. [ "$ICFGN" -ne '0' ] && {  
  165. for NetCFG in `ls -1 /etc/network/interfaces.d/*.cfg`  
  166. do   
  167.   [[ -z "$(cat $NetCFG | sed -n '/iface.*inet static/p')" ]] && AutoNet='1' || AutoNet='0'  
  168.   [ "$AutoNet" -eq '0' ] && break  
  169. done  
  170. }  
  171. }  
  172. }  
  173. [ -d /etc/sysconfig/network-scripts ] && {  
  174. ICFGN="$(find /etc/sysconfig/network-scripts -name 'ifcfg-*' |grep -v 'lo'|wc -l)" || ICFGN='0'  
  175. [ "$ICFGN" -ne '0' ] && {  
  176. for NetCFG in `ls -1 /etc/sysconfig/network-scripts/ifcfg-* |grep -v 'lo$' |grep -v ':[0-9]\{1,\}'`  
  177. do   
  178.   [[ -n "$(cat $NetCFG | sed -n '/BOOTPROTO.*[dD][hH][cC][pP]/p')" ]] && AutoNet='1' || {  
  179.   AutoNet='0' && . $NetCFG  
  180.   [ -n $NETMASK ] && MASK="$NETMASK"  
  181.   [ -n $GATEWAY ] && GATE="$GATEWAY"  
  182. }  
  183.   [ "$AutoNet" -eq '0' ] && break  
  184. done  
  185. }  
  186. }  
  187.    
  188. [ ! -f $GRUBDIR/$GRUBFILE ] && echo "Error! Not Found $GRUBFILE. " && exit 1  
  189.    
  190. [ ! -f $GRUBDIR/$GRUBFILE.old ] && [ -f $GRUBDIR/$GRUBFILE.bak ] && mv -f $GRUBDIR/$GRUBFILE.bak $GRUBDIR/$GRUBFILE.old  
  191. mv -f $GRUBDIR/$GRUBFILE $GRUBDIR/$GRUBFILE.bak  
  192. [ -f $GRUBDIR/$GRUBFILE.old ] && cat $GRUBDIR/$GRUBFILE.old >$GRUBDIR/$GRUBFILE || cat $GRUBDIR/$GRUBFILE.bak >$GRUBDIR/$GRUBFILE  
  193.    
  194. [ "$GRUBOLD" == '0' ] && {  
  195. CFG0="$(awk '/menuentry /{print NR}' $GRUBDIR/$GRUBFILE|head -n 1)"  
  196. CFG2="$(awk '/menuentry /{print NR}' $GRUBDIR/$GRUBFILE|head -n 2 |tail -n 1)"  
  197. CFG1=""  
  198. for CFGtmp in `awk '/}/{print NR}' $GRUBDIR/$GRUBFILE`  
  199. do  
  200.   [ $CFGtmp -gt "$CFG0" -a $CFGtmp -lt "$CFG2" ] && CFG1="$CFGtmp";  
  201. done  
  202. [ -z "$CFG1" ] && {  
  203. echo "Error! read $GRUBFILE. "  
  204. exit 1  
  205. }  
  206. sed -n "$CFG0,$CFG1"p $GRUBDIR/$GRUBFILE >/tmp/grub.new  
  207. [ -f /tmp/grub.new ] && [ "$(grep -c '{' /tmp/grub.new)" -eq "$(grep -c '}' /tmp/grub.new)" ] || {  
  208. echo -ne "\033[31mError! \033[0mNot configure $GRUBFILE. \n"  
  209. exit 1  
  210. }  
  211.    
  212. sed -i "/menuentry.*/c\menuentry\ \'Install OS \[$vDEB\ $VER\]\'\ --class debian\ --class\ gnu-linux\ --class\ gnu\ --class\ os\ \{" /tmp/grub.new  
  213. [ "$(grep -c '{' /tmp/grub.new)" -eq "$(grep -c '}' /tmp/grub.new)" ] || {  
  214. echo "Error! configure append $GRUBFILE. "  
  215. exit 1  
  216. }  
  217. sed -i "/echo.*Loading/d" /tmp/grub.new  
  218. }  
  219.    
  220. [ "$GRUBOLD" == '1' ] && {  
  221. CFG0="$(awk '/title /{print NR}' $GRUBDIR/$GRUBFILE|head -n 1)"  
  222. CFG1="$(awk '/title /{print NR}' $GRUBDIR/$GRUBFILE|head -n 2 |tail -n 1)"  
  223. [ -n $CFG0 ] && [ -z $CFG1 -o $CFG1 == $CFG0 ] && sed -n "$CFG0,$"p $GRUBDIR/$GRUBFILE >/tmp/grub.new  
  224. [ -n $CFG0 ] && [ -z $CFG1 -o $CFG1 != $CFG0 ] && sed -n "$CFG0,$CFG1"p $GRUBDIR/$GRUBFILE >/tmp/grub.new  
  225. [ ! -f /tmp/grub.new ] && echo "Error! configure append $GRUBFILE. " && exit 1  
  226. sed -i "/title.*/c\title\ \'Install OS \[$vDEB\ $VER\]\'" /tmp/grub.new  
  227. sed -i '/^#/d' /tmp/grub.new  
  228. }  
  229.    
  230. [ -n "$(grep 'initrd.*/' /tmp/grub.new |awk '{print $2}' |tail -n 1 |grep '^/boot/')" ] && Type='InBoot' || Type='NoBoot'  
  231.    
  232. LinuxKernel="$(grep 'linux.*/' /tmp/grub.new |awk '{print $1}' |head -n 1)"  
  233. [ -z $LinuxKernel ] && LinuxKernel="$(grep 'kernel.*/' /tmp/grub.new |awk '{print $1}' |head -n 1)"  
  234. LinuxIMG="$(grep 'initrd.*/' /tmp/grub.new |awk '{print $1}' |tail -n 1)"  
  235.    
  236. [ "$Type" == 'InBoot' ] && {  
  237. sed -i "/$LinuxKernel.*\//c\\\t$LinuxKernel\\t\/boot\/linux auto=true hostname=$linuxdists domain= -- quiet" /tmp/grub.new  
  238. sed -i "/$LinuxIMG.*\//c\\\t$LinuxIMG\\t\/boot\/initrd.gz" /tmp/grub.new  
  239. }  
  240.    
  241. [ "$Type" == 'NoBoot' ] && {  
  242. sed -i "/$LinuxKernel.*\//c\\\t$LinuxKernel\\t\/linux auto=true hostname=$linuxdists domain= -- quiet" /tmp/grub.new  
  243. sed -i "/$LinuxIMG.*\//c\\\t$LinuxIMG\\t\/initrd.gz" /tmp/grub.new  
  244. }  
  245.    
  246. sed -i '$a\\n' /tmp/grub.new  
  247.    
  248. [ "$inVNC" == 'n' ] && {  
  249. GRUBPATCH='0'  
  250. [ -f /etc/network/interfaces -o -d /etc/sysconfig/network-scripts ] && {  
  251. sed -i ''${CFG0}'i\\n' $GRUBDIR/$GRUBFILE  
  252. sed -i ''${CFG0}'r /tmp/grub.new' $GRUBDIR/$GRUBFILE  
  253. [ -z $AutoNet ] && echo "Error, Not found interfaces config." && exit 1  
  254. [ -f  $GRUBDIR/grubenv ] && sed -i 's/saved_entry/#saved_entry/g' $GRUBDIR/grubenv  
  255. [ -d /boot/tmp ] && rm -rf /boot/tmp  
  256. mkdir -p /boot/tmp/  
  257. cd /boot/tmp/  
  258. gzip -d < ../initrd.gz | cpio --extract --verbose --make-directories --no-absolute-filenames >>/dev/null 2>&1  
  259. cat >/boot/tmp/preseed.cfg<<EOF  
  260. d-i debian-installer/locale string en_US  
  261. d-i console-setup/layoutcode string us  
  262.    
  263. d-i keyboard-configuration/xkb-keymap string us  
  264.    
  265. d-i netcfg/choose_interface select auto  
  266.    
  267. d-i netcfg/disable_autoconfig boolean true  
  268. d-i netcfg/dhcp_failed note  
  269. d-i netcfg/dhcp_options select Configure network manually  
  270. d-i netcfg/get_ipaddress string $IPv4  
  271. d-i netcfg/get_netmask string $MASK  
  272. d-i netcfg/get_gateway string $GATE  
  273. d-i netcfg/get_nameservers string 8.8.8.8  
  274. d-i netcfg/no_default_route boolean true  
  275. d-i netcfg/confirm_static boolean true  
  276.    
  277. d-i mirror/country string manual  
  278. d-i mirror/http/hostname string $DebianMirror  
  279. d-i mirror/http/directory string $DebianMirrorDirectory  
  280. d-i mirror/http/proxy string  
  281.    
  282. d-i passwd/root-login boolean ture  
  283. d-i passwd/make-user boolean false  
  284. d-i passwd/root-password password $myPASSWORD  
  285. d-i passwd/root-password-again password $myPASSWORD  
  286. d-i user-setup/allow-password-weak boolean true  
  287. d-i user-setup/encrypt-home boolean false  
  288.    
  289. d-i clock-setup/utc boolean true  
  290. d-i time/zone string US/Eastern  
  291. d-i clock-setup/ntp boolean true  
  292.    
  293. d-i partman/early_command string \  
  294. debconf-set partman-auto/disk "\$(list-devices disk |head -n1)"; \  
  295. debconf-set grub-installer/bootdev string "\$(list-devices disk |head -n1)"; \  
  296. umount /media || true;  
  297. d-i partman/mount_style select uuid  
  298. d-i partman-auto/init_automatically_partition select Guided - use entire disk  
  299. d-i partman-auto/method string regular  
  300. d-i partman-lvm/device_remove_lvm boolean true  
  301. d-i partman-md/device_remove_md boolean true  
  302. d-i partman-auto/choose_recipe select atomic  
  303. d-i partman-partitioning/confirm_write_new_label boolean true  
  304. d-i partman/choose_partition select finish  
  305. d-i partman-lvm/confirm boolean true  
  306. d-i partman-lvm/confirm_nooverwrite boolean true  
  307. d-i partman/confirm boolean true  
  308. d-i partman/confirm_nooverwrite boolean true  
  309.    
  310. d-i debian-installer/allow_unauthenticated boolean true  
  311.    
  312. tasksel tasksel/first multiselect minimal  
  313. d-i pkgsel/update-policy select none  
  314. d-i pkgsel/include string openssh-server  
  315. d-i pkgsel/upgrade select none  
  316.    
  317. popularity-contest popularity-contest/participate boolean false  
  318.    
  319. d-i grub-installer/only_debian boolean true  
  320. d-i grub-installer/bootdev string default  
  321. d-i finish-install/reboot_in_progress note  
  322. d-i debian-installer/exit/reboot boolean true  
  323. d-i preseed/late_command string \  
  324. sed -i 's/^.*PermitRootLogin.*/PermitRootLogin yes/g' /target/etc/ssh/sshd_config; \  
  325. sed -i 's/^.*PasswordAuthentication.*/PasswordAuthentication yes/g' /target/etc/ssh/sshd_config;  
  326. EOF  
  327. [ "$AutoNet" -eq '1' ] && {  
  328. sed -i '/netcfg\/disable_autoconfig/d' /boot/tmp/preseed.cfg  
  329. sed -i '/netcfg\/dhcp_options/d' /boot/tmp/preseed.cfg  
  330. sed -i '/netcfg\/get_.*/d' /boot/tmp/preseed.cfg  
  331. sed -i '/netcfg\/confirm_static/d' /boot/tmp/preseed.cfg  
  332. }  
  333. [ "$vDEB" == 'trusty' ] && GRUBPATCH='1'  
  334. [ "$vDEB" == 'wily' ] && GRUBPATCH='1'  
  335. [ "$GRUBPATCH" == '1' ] && {  
  336. sed -i 's/^d-i\ grub-installer\/bootdev\ string\ default//g' /boot/tmp/preseed.cfg  
  337. }  
  338. [ "$GRUBPATCH" == '0' ] && {  
  339. sed -i 's/debconf-set\ grub-installer\/bootdev.*\"\;//g' /boot/tmp/preseed.cfg  
  340. }  
  341. [ "$linuxdists" == 'debian' ] && {  
  342. sed -i '/user-setup\/allow-password-weak/d' /boot/tmp/preseed.cfg  
  343. sed -i '/user-setup\/encrypt-home/d' /boot/tmp/preseed.cfg  
  344. sed -i '/pkgsel\/update-policy/d' /boot/tmp/preseed.cfg  
  345. sed -i 's/umount\ \/media.*\;//g' /boot/tmp/preseed.cfg  
  346. }  
  347. rm -rf ../initrd.gz  
  348. find . | cpio -H newc --create --verbose | gzip -9 > ../initrd.gz  
  349. rm -rf /boot/tmp  
  350. }  
  351. }  
  352.    
  353. [ "$inVNC" == 'y' ] && {  
  354. sed -i '$i\\n' $GRUBDIR/$GRUBFILE  
  355. sed -i '$r /tmp/grub.new' $GRUBDIR/$GRUBFILE  
  356. echo -e "\n\033[33m\033[04mIt will reboot! \nPlease look at VNC! \nSelect\033[0m\033[32m Install OS [$vDEB $VER] \033[33m\033[4mto install system.\033[04m\n\n\033[31m\033[04mThere is some information for you.\nDO NOT CLOSE THE WINDOW! \033[0m\n"  
  357. echo -e "\033[35mIPv4\t\tNETMASK\t\tGATEWAY\033[0m"  
  358. echo -e "\033[36m\033[04m$IPv4\033[0m\t\033[36m\033[04m$MASK\033[0m\t\033[36m\033[04m$GATE\033[0m\n\n"  
  359.    
  360. read -n 1 -p "Press Enter to reboot..." INP  
  361. if [ "$INP" != '' ] ; then  
  362. echo -ne '\b \n'  
  363. echo "";  
  364. fi  
  365. }  
  366.    
  367. chown root:root $GRUBDIR/$GRUBFILE  
  368. chmod 444 $GRUBDIR/$GRUBFILE  
  369.    
  370. sleep 3 && reboot >/dev/null 2>&1  
注意事项:
在安装Ubuntu时,可能会遇到:
Getting the time form a network time server...
界面进度条很长时间不会动,可以等待它超时或者更换别的版本.
该问题是Ubuntu系统的问题.
确保安装了所需软件.

« 上一篇 | 下一篇 »

发表评论

评论内容 (必填):